#pragma once

#include<string>

// definice makra
#define ZAMESTNANEC

// zruseni makra
#undef ZAMESTNANEC 

//using T = int;
// using T = float;

#ifdef ZAMESTNANEC

struct Zamestnanec
{
	std::string jmeno;
	std::string prijmeni;
	int plat;
};

 using T = Zamestnanec;

#else
 using T = int;
#endif

 
struct Prvek
{
	T data;
	Prvek *dalsi = nullptr;
};

struct Seznam
{
	Prvek *hlava = nullptr;
	Prvek *zarazka = nullptr;
};

void vytvor(Seznam &s);
void smazVsechny(Seznam &s);
void zrus(Seznam &s);
bool jePrazdny(Seznam &s);

void vlozNaZacatek(Seznam &s, T co);
void vlozNaKonec(Seznam &s, T co);

void vypis(Seznam &s);

T vyjmiPrvni(Seznam &s);
void smazPrvni(Seznam &s);

T vyjmiPosledni(Seznam &s);
void smazPosledni(Seznam &s);

Prvek *najdi(Seznam &s, T co);

void vlozZa(Seznam &s, Prvek *predchazejici, T co);
T vyjmiPrvekZa(Seznam &s, Prvek *predchazejici);
void smazPrvekZa(Seznam &s, Prvek *predchazejici);

void smazPrvek(Seznam &s, Prvek *mazany);

T* maximum(Seznam &s);
void setrid(Seznam &s);

void ulozSeznam(Seznam &s, std::string nazev);
void nactiSeznam(Seznam &s, std::string nazev);


